Page MenuHomePhabricator

Update submodules from cache
AbandonedPublic

Authored by thcipriani on Jun 27 2016, 10:03 PM.

Details

Maniphest Tasks
T137124: Scap3 submodule space issues
Reviewers
mmodell
demon
hashar
Group Reviewers
Release-Engineering-Team
Patch without arc
git checkout -b D284 && curl -L https://phabricator.wikimedia.org/D284?download=true | git apply
Summary

Since local git clones use hardlinks for objects, space isn't much of a
consideration for additional local clones. Space *is* a consideration
for submodules since we have been registering submodules for individual
revdirs; pointing .gitmodules to the git_server rather than the cache
dir.

This patch initializes and registers submodules in the cache directory
and remaps each rev to use objects from the cache dir (which is local,
so it creates hardlinks). Potentially saves disk-space for deploys were
submodules represent the majority of code/objects.

Fixes T137124

Diff Detail

Event Timeline

thcipriani updated this revision to Diff 768.Jun 27 2016, 10:03 PM
thcipriani retitled this revision from to Update submodules from cache.
thcipriani updated this object.
thcipriani edited the test plan for this revision. (Show Details)
thcipriani added reviewers: mmodell, demon, hashar.
Restricted Application added a reviewer: Release-Engineering-Team. · View Herald TranscriptJun 27 2016, 10:03 PM
Restricted Application added a project: Release-Engineering-Team. · View Herald Transcript
thcipriani edited edge metadata.Jun 27 2016, 10:04 PM
thcipriani added subscribers: Ladsgroup, akosiaris.

LGTM. I can't test it though. It would be great to see how it works in beta cluster.

mmodell accepted this revision.Jun 29 2016, 7:16 PM
mmodell edited edge metadata.
This revision is now accepted and ready to land.Jun 29 2016, 7:16 PM
thcipriani abandoned this revision.Sep 9 2016, 8:55 PM

Still not sure this is the right way to do this. Seems like this might be prone to breakage.